;;;
;;;
;;;                Lisp-Routine ndert die Farbe von Attributen, Linien, Texten, etc.
;;;                auch in Blcken
;;;
;;;
;;;
;;;
;;;Fehler-Routine
(defun ve_error (emsg)
  (if (/= emsg "Funktion abgebrochen")
      (princ (strcat "\nFehler: " emsg))
      )
  (altsv)
  (princ)
)

;;;Einstellungen zurckstellen
(defun altsv ()
  (setvar "CMDECHO" cmde)
  (setvar "OSMODE" osm)
  (setq *error* old_error)
  (command "._regen")
)

;;;Hauptprogramm
(defun C:CF ()
  (defun dxf (X) (cdr (assoc X atl)))
  (setq old_error *error*
         *error* ve_error
   )
  (setq cmde (getvar "CMDECHO"))
  (setq osm (getvar "OSMODE"))
  (setvar "CMDECHO" 0)
  (setvar "BLIPMODE" 0)
  (SETVAR "OSMODE" 0)
  (setq en (car (nentsel "\nElement whlen: ")))
  (while en
    (setq atl (entget en))
    (if	(dxf 62)
      (setq fa (dxf 62))
      (progn
	(setq laynam (dxf 8))
	(setq fa (cdr (assoc 62 (tblsearch "LAYER" laynam))))
      )
    )
    (if	fn
      (setq fa fn)
    )
    (setq
      fntemp (getint (strcat "\nNeue Farbnummer <" (itoa fa) ">: "))
    )
    (if	(not fntemp)
      (setq fn fa)
      (setq fn fntemp)
    )
    (if	(dxf 62)
      (progn
	(setq atl (subst (cons 62 fn) (assoc 62 atl) atl))
      )
      (progn
	(setq atl1 (reverse (member (assoc 8 atl) (reverse atl))))
	(setq atl2 (cdr (member (assoc 8 atl) atl)))
	(setq atl (append atl1 (cons (cons 62 fn) atl2)))
      )
    )
    (entmod atl)
    (redraw en)
    (setq en (car (nentsel "\nElement whlen: ")))
  )
  (altsv)
  (princ)
)
